# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 20
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from isilon_sdk.v9_9_0.models.maintenance_settings_component import MaintenanceSettingsComponent  # noqa: F401,E501
from isilon_sdk.v9_9_0.models.maintenance_settings_history_item import MaintenanceSettingsHistoryItem  # noqa: F401,E501


class MaintenanceSettings(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'active': 'bool',
        'auto_enable': 'bool',
        'components': 'list[MaintenanceSettingsComponent]',
        'history': 'list[MaintenanceSettingsHistoryItem]',
        'manual_window_enabled': 'bool',
        'manual_window_hours': 'int',
        'manual_window_start': 'int'
    }

    attribute_map = {
        'active': 'active',
        'auto_enable': 'auto_enable',
        'components': 'components',
        'history': 'history',
        'manual_window_enabled': 'manual_window_enabled',
        'manual_window_hours': 'manual_window_hours',
        'manual_window_start': 'manual_window_start'
    }

    def __init__(self, active=None, auto_enable=None, components=None, history=None, manual_window_enabled=None, manual_window_hours=None, manual_window_start=None):  # noqa: E501
        """MaintenanceSettings - a model defined in Swagger"""  # noqa: E501

        self._active = None
        self._auto_enable = None
        self._components = None
        self._history = None
        self._manual_window_enabled = None
        self._manual_window_hours = None
        self._manual_window_start = None
        self.discriminator = None

        self.active = active
        self.auto_enable = auto_enable
        if components is not None:
            self.components = components
        if history is not None:
            self.history = history
        self.manual_window_enabled = manual_window_enabled
        self.manual_window_hours = manual_window_hours
        self.manual_window_start = manual_window_start

    @property
    def active(self):
        """Gets the active of this MaintenanceSettings.  # noqa: E501

        Indicates whether maintenance mode is active.  # noqa: E501

        :return: The active of this MaintenanceSettings.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this MaintenanceSettings.

        Indicates whether maintenance mode is active.  # noqa: E501

        :param active: The active of this MaintenanceSettings.  # noqa: E501
        :type: bool
        """
        if active is None:
            raise ValueError("Invalid value for `active`, must not be `None`")  # noqa: E501

        self._active = active

    @property
    def auto_enable(self):
        """Gets the auto_enable of this MaintenanceSettings.  # noqa: E501

        Indicates whether auto maintenance mode is enabled.  # noqa: E501

        :return: The auto_enable of this MaintenanceSettings.  # noqa: E501
        :rtype: bool
        """
        return self._auto_enable

    @auto_enable.setter
    def auto_enable(self, auto_enable):
        """Sets the auto_enable of this MaintenanceSettings.

        Indicates whether auto maintenance mode is enabled.  # noqa: E501

        :param auto_enable: The auto_enable of this MaintenanceSettings.  # noqa: E501
        :type: bool
        """
        if auto_enable is None:
            raise ValueError("Invalid value for `auto_enable`, must not be `None`")  # noqa: E501

        self._auto_enable = auto_enable

    @property
    def components(self):
        """Gets the components of this MaintenanceSettings.  # noqa: E501

        Maintenance mode status of individual components.  # noqa: E501

        :return: The components of this MaintenanceSettings.  # noqa: E501
        :rtype: list[MaintenanceSettingsComponent]
        """
        return self._components

    @components.setter
    def components(self, components):
        """Sets the components of this MaintenanceSettings.

        Maintenance mode status of individual components.  # noqa: E501

        :param components: The components of this MaintenanceSettings.  # noqa: E501
        :type: list[MaintenanceSettingsComponent]
        """

        self._components = components

    @property
    def history(self):
        """Gets the history of this MaintenanceSettings.  # noqa: E501

        History list of maintenance mode windows.  # noqa: E501

        :return: The history of this MaintenanceSettings.  # noqa: E501
        :rtype: list[MaintenanceSettingsHistoryItem]
        """
        return self._history

    @history.setter
    def history(self, history):
        """Sets the history of this MaintenanceSettings.

        History list of maintenance mode windows.  # noqa: E501

        :param history: The history of this MaintenanceSettings.  # noqa: E501
        :type: list[MaintenanceSettingsHistoryItem]
        """

        self._history = history

    @property
    def manual_window_enabled(self):
        """Gets the manual_window_enabled of this MaintenanceSettings.  # noqa: E501

        Indicates whether the manual maintenance window enabled.  # noqa: E501

        :return: The manual_window_enabled of this MaintenanceSettings.  # noqa: E501
        :rtype: bool
        """
        return self._manual_window_enabled

    @manual_window_enabled.setter
    def manual_window_enabled(self, manual_window_enabled):
        """Sets the manual_window_enabled of this MaintenanceSettings.

        Indicates whether the manual maintenance window enabled.  # noqa: E501

        :param manual_window_enabled: The manual_window_enabled of this MaintenanceSettings.  # noqa: E501
        :type: bool
        """
        if manual_window_enabled is None:
            raise ValueError("Invalid value for `manual_window_enabled`, must not be `None`")  # noqa: E501

        self._manual_window_enabled = manual_window_enabled

    @property
    def manual_window_hours(self):
        """Gets the manual_window_hours of this MaintenanceSettings.  # noqa: E501

        When the manual maintenance window is enabled, the duration of the window in hours.  # noqa: E501

        :return: The manual_window_hours of this MaintenanceSettings.  # noqa: E501
        :rtype: int
        """
        return self._manual_window_hours

    @manual_window_hours.setter
    def manual_window_hours(self, manual_window_hours):
        """Sets the manual_window_hours of this MaintenanceSettings.

        When the manual maintenance window is enabled, the duration of the window in hours.  # noqa: E501

        :param manual_window_hours: The manual_window_hours of this MaintenanceSettings.  # noqa: E501
        :type: int
        """
        if manual_window_hours is None:
            raise ValueError("Invalid value for `manual_window_hours`, must not be `None`")  # noqa: E501
        if manual_window_hours is not None and manual_window_hours > 199:  # noqa: E501
            raise ValueError("Invalid value for `manual_window_hours`, must be a value less than or equal to `199`")  # noqa: E501
        if manual_window_hours is not None and manual_window_hours < 1:  # noqa: E501
            raise ValueError("Invalid value for `manual_window_hours`, must be a value greater than or equal to `1`")  # noqa: E501

        self._manual_window_hours = manual_window_hours

    @property
    def manual_window_start(self):
        """Gets the manual_window_start of this MaintenanceSettings.  # noqa: E501

        When the manual maintenance window is enabled, the time when the maintenance window will start.  # noqa: E501

        :return: The manual_window_start of this MaintenanceSettings.  # noqa: E501
        :rtype: int
        """
        return self._manual_window_start

    @manual_window_start.setter
    def manual_window_start(self, manual_window_start):
        """Sets the manual_window_start of this MaintenanceSettings.

        When the manual maintenance window is enabled, the time when the maintenance window will start.  # noqa: E501

        :param manual_window_start: The manual_window_start of this MaintenanceSettings.  # noqa: E501
        :type: int
        """
        if manual_window_start is None:
            raise ValueError("Invalid value for `manual_window_start`, must not be `None`")  # noqa: E501
        if manual_window_start is not None and manual_window_start > 9223372036854775807:  # noqa: E501
            raise ValueError("Invalid value for `manual_window_start`, must be a value less than or equal to `9223372036854775807`")  # noqa: E501
        if manual_window_start is not None and manual_window_start < 0:  # noqa: E501
            raise ValueError("Invalid value for `manual_window_start`, must be a value greater than or equal to `0`")  # noqa: E501

        self._manual_window_start = manual_window_start

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MaintenanceSettings):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
