# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 20
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class OauthOauth2Clients(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'authorization_code_flow': 'bool',
        'client_name': 'str',
        'client_security_level': 'str',
        'id': 'str',
        'redirect_uris': 'list[str]',
        'token_exchange_enabled': 'bool'
    }

    attribute_map = {
        'authorization_code_flow': 'authorization_code_flow',
        'client_name': 'client_name',
        'client_security_level': 'client_security_level',
        'id': 'id',
        'redirect_uris': 'redirect_uris',
        'token_exchange_enabled': 'token_exchange_enabled'
    }

    def __init__(self, authorization_code_flow=None, client_name=None, client_security_level=None, id=None, redirect_uris=None, token_exchange_enabled=None):  # noqa: E501
        """OauthOauth2Clients - a model defined in Swagger"""  # noqa: E501

        self._authorization_code_flow = None
        self._client_name = None
        self._client_security_level = None
        self._id = None
        self._redirect_uris = None
        self._token_exchange_enabled = None
        self.discriminator = None

        if authorization_code_flow is not None:
            self.authorization_code_flow = authorization_code_flow
        if client_name is not None:
            self.client_name = client_name
        if client_security_level is not None:
            self.client_security_level = client_security_level
        if id is not None:
            self.id = id
        if redirect_uris is not None:
            self.redirect_uris = redirect_uris
        if token_exchange_enabled is not None:
            self.token_exchange_enabled = token_exchange_enabled

    @property
    def authorization_code_flow(self):
        """Gets the authorization_code_flow of this OauthOauth2Clients.  # noqa: E501

        When true, the authorization code flow will be supported.  # noqa: E501

        :return: The authorization_code_flow of this OauthOauth2Clients.  # noqa: E501
        :rtype: bool
        """
        return self._authorization_code_flow

    @authorization_code_flow.setter
    def authorization_code_flow(self, authorization_code_flow):
        """Sets the authorization_code_flow of this OauthOauth2Clients.

        When true, the authorization code flow will be supported.  # noqa: E501

        :param authorization_code_flow: The authorization_code_flow of this OauthOauth2Clients.  # noqa: E501
        :type: bool
        """

        self._authorization_code_flow = authorization_code_flow

    @property
    def client_name(self):
        """Gets the client_name of this OauthOauth2Clients.  # noqa: E501

        User friendly name for OAuth2 client.  # noqa: E501

        :return: The client_name of this OauthOauth2Clients.  # noqa: E501
        :rtype: str
        """
        return self._client_name

    @client_name.setter
    def client_name(self, client_name):
        """Sets the client_name of this OauthOauth2Clients.

        User friendly name for OAuth2 client.  # noqa: E501

        :param client_name: The client_name of this OauthOauth2Clients.  # noqa: E501
        :type: str
        """
        if client_name is not None and len(client_name) > 255:
            raise ValueError("Invalid value for `client_name`, length must be less than or equal to `255`")  # noqa: E501
        if client_name is not None and len(client_name) < 1:
            raise ValueError("Invalid value for `client_name`, length must be greater than or equal to `1`")  # noqa: E501

        self._client_name = client_name

    @property
    def client_security_level(self):
        """Gets the client_security_level of this OauthOauth2Clients.  # noqa: E501

        TRUSTED if the refresh token can be returned in the client credential flow.  # noqa: E501

        :return: The client_security_level of this OauthOauth2Clients.  # noqa: E501
        :rtype: str
        """
        return self._client_security_level

    @client_security_level.setter
    def client_security_level(self, client_security_level):
        """Sets the client_security_level of this OauthOauth2Clients.

        TRUSTED if the refresh token can be returned in the client credential flow.  # noqa: E501

        :param client_security_level: The client_security_level of this OauthOauth2Clients.  # noqa: E501
        :type: str
        """
        allowed_values = ["TRUSTED", "REGULAR"]  # noqa: E501
        if client_security_level not in allowed_values:
            raise ValueError(
                "Invalid value for `client_security_level` ({0}), must be one of {1}"  # noqa: E501
                .format(client_security_level, allowed_values)
            )

        self._client_security_level = client_security_level

    @property
    def id(self):
        """Gets the id of this OauthOauth2Clients.  # noqa: E501

        Unique identifier of OAuth2 client.  # noqa: E501

        :return: The id of this OauthOauth2Clients.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this OauthOauth2Clients.

        Unique identifier of OAuth2 client.  # noqa: E501

        :param id: The id of this OauthOauth2Clients.  # noqa: E501
        :type: str
        """
        if id is not None and len(id) > 255:
            raise ValueError("Invalid value for `id`, length must be less than or equal to `255`")  # noqa: E501
        if id is not None and len(id) < 1:
            raise ValueError("Invalid value for `id`, length must be greater than or equal to `1`")  # noqa: E501

        self._id = id

    @property
    def redirect_uris(self):
        """Gets the redirect_uris of this OauthOauth2Clients.  # noqa: E501

        Array of URIs to which the client wants to redirect.  # noqa: E501

        :return: The redirect_uris of this OauthOauth2Clients.  # noqa: E501
        :rtype: list[str]
        """
        return self._redirect_uris

    @redirect_uris.setter
    def redirect_uris(self, redirect_uris):
        """Sets the redirect_uris of this OauthOauth2Clients.

        Array of URIs to which the client wants to redirect.  # noqa: E501

        :param redirect_uris: The redirect_uris of this OauthOauth2Clients.  # noqa: E501
        :type: list[str]
        """

        self._redirect_uris = redirect_uris

    @property
    def token_exchange_enabled(self):
        """Gets the token_exchange_enabled of this OauthOauth2Clients.  # noqa: E501

        When true, the token exchange flow will be supported.  # noqa: E501

        :return: The token_exchange_enabled of this OauthOauth2Clients.  # noqa: E501
        :rtype: bool
        """
        return self._token_exchange_enabled

    @token_exchange_enabled.setter
    def token_exchange_enabled(self, token_exchange_enabled):
        """Sets the token_exchange_enabled of this OauthOauth2Clients.

        When true, the token exchange flow will be supported.  # noqa: E501

        :param token_exchange_enabled: The token_exchange_enabled of this OauthOauth2Clients.  # noqa: E501
        :type: bool
        """

        self._token_exchange_enabled = token_exchange_enabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OauthOauth2Clients):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
